	.286
;
;
;
;
;
;
; This program was designed as a power on logo for the DARIUS range of
; machines. DARIUS (from Vancouver, Canada) no longer exists. I programmed
; this for a static demo to show the speed of the VGA and used as a
; single logo in the top left corner of the screen during ram testing on
; power up. It's a real shame these machines never made it to the market.
;
;
;
; There are three options below that can be set to 0 or 1. They produce
; different combinations of logo, or different speed of logo.
;
;
; This demo cheats badly (but not at all noticable) - and people will think
; you have an amazingly fast processor and VGA card.
;
;
; Because all the darius machine were VGA and 386s this has not be tried on
; anything else, but it should work on EGA's and 286's.
;
;
; If you want a bios programmer (esp. if you are based in Vancouver!), or
; a nicer power on logo for a machine, or just a demo, give me a call.
;
;
;
; Work: (England) 01144  71-978-1844.
;
; Andrew Glaister
;
;
;
;
;
;
; To assemble this program use MASM LOGO; then LINK LOGO;
;
;
;
;
;
;
;
WIZZ	EQU 1		;Speed of spinning (1=Fast, 0=Slow)
LOTS	EQU 1		;Cover screen in logos
SHIFTED	EQU 1		;Shift logos across the screen
;
;
;
;
;
;
;
;
;
;
;
;
;
;
deven	MACRO
;	ALIGN 4
	ENDM
;
;
CLK10	EQU 4000
SEQADDR	EQU 3C4H
RESETD	EQU 0
CLKMODD	EQU 1
NOSYNKRES	EQU 2
NOASYNKRES	EQU 1
DOTS8	EQU 1
NOTODEV	EQU 4
EXTMEM	EQU 2
ALPHA	EQU 0
EGAHASMONO	EQU 2
ODEVADR	EQU 10H
WMPROC	EQU 0
MAPMSKD	EQU 2
CHMAPD	EQU 3
MEMODD	EQU 4
MISCOR	EQU 3C2H
CLK25M	EQU 0
CRTCADDM	EQU 3B4H
CRTCADDC	EQU 3D4H
CURSLHD	EQU 0EH
GRA12AD	EQU 3CEH
MODREGD	EQU 5
RMAPSED	EQU 4
MISREGD	EQU 6
MA000	EQU 4
ATTCTLP	EQU 3C0H
HORPPAN	EQU 13H
CHNMAPS	EQU 2
;
DS40H	SEGMENT AT 40H
	ORG 10H
DEVFLG	DW ?
	ORG 49H
CRTMODE	DB ?
	ORG 50H
CURCOOR	DW ?
	ORG 85H
SCRNBPC	DW ?
	ORG 87H
EGADATA	DB ?
DS40H	ENDS
;
;
;




FONT	SEGMENT AT 0A400H
FONT	ENDS






DATA	SEGMENT AT 07000H
	ORG 0
;
;0: Xfrac
;1: X
;2: Xstep
;3: Xstep sign
;4: Yfrac
;5: Y
;6: Ystep
;7: Ystep sign
;
;8-15 = Same as above for x2,y2
;
;
LOGO	DB 32*16 DUP (?)	;Storage for 32 lines	
;
COUNT	DW ?
LASTL	DW ?
FUNCTION	DW ?
MCOUNT	DB ?,?
X1	DB ?
Y1	DB ?
X2	DB ?
Y2	DB ?
LEAF	DW ?
LROUTINE	DW ?
INC1	DW ?
INC2	DW ?
DATA	ENDS






CODE	SEGMENT
	ASSUME CS:CODE,DS:DS40H

;
;
;
; X1,Y1 X2,Y2 'COMPUTER' coordinates
;
;
COMPDAT	DB 34,44,19,44
	DB 18,44,18,28
	DB 19,28,34,28
;O
	DB 37,28,53,28
	DB 53,29,53,43
	DB 53,44,37,44
	DB 37,43,37,29
;M
	DB 56,44,56,29
	DB 56,28,64,36
	DB 65,35,72,28
	DB 72,29,72,44
;P
	DB 75,44,75,28
	DB 76,28,91,32
	DB 91,32,76,36
;U
	DB 94,28,94,44
	DB 95,44,110,44
	DB 110,43,110,28
;T
	DB 113,28,129,28
	DB 121,29,121,44
;E
	DB 148,44,133,44
	DB 132,44,132,28
	DB 133,28,148,28
	DB 146,36,133,36
;R
	DB 151,44,151,28
	DB 152,28,167,32
	DB 167,32,152,36
	DB 152,36,167,44
;S
	DB 170,44,186,44
	DB 186,43,186,36
	DB 185,36,171,36
	DB 170,36,170,29
	DB 170,28,186,28
;
; X1,Y1,X2,Y2 Logo coordinates
;
; 8,20 = Top left
; 200,52 = Bottom right
;
LOGODAT	DB 26,52,8,52
	DB 8,51,8,21
	DB 8,20,31,20
	DB 32,20,43,31
	DB 43,32,43,36
;A
	DB 29,52,72,20
	DB 36,52,78,20
	DB 42,52,85,20
	DB 66,36,85,36
	DB 87,52,87,20
;R
	DB 126,52,87,36
	DB 87,36,116,36
	DB 117,36,126,30
	DB 126,29,126,26
	DB 126,25,117,20
	DB 116,20,88,20
;I
	DB 132,20,132,52
;U
	DB 138,20,138,37
	DB 138,38,141,46
	DB 142,47,148,52
	DB 149,52,159,52
	DB 160,52,167,45
	DB 167,44,171,36
;S
	DB 172,52,187,52
	DB 188,52,198,46
	DB 198,45,198,42
	DB 198,41,188,36
	DB 187,36,181,36
	DB 180,36,172,30
	DB 172,29,172,26
	DB 172,25,180,20
	DB 181,20,194,20
;
; Table of routines for different setups
;
SETUP	DW ROTY,SCRAMBLE,ROTX,SQU1,FLAT1,EXPLO,FLAT2,XSQB
TREPEAT	DW 4,4,4,4,6,4,6,4
TLREP	EQU $






START:	MOV AX,DS40H
	MOV DS,AX
	CLD
	MOV AX,3
	INT 10H
	CALL PLOGO_BUILD
	MOV AH,7
	INT 21H
	CALL PLOGO_DONE
	MOV AX,3
	INT 10H
	MOV AX,4C00H
	INT 21H
ANYOLDRET:	RET
;
;
;
;
;
;
;
;
PLOGO_BUILD:	CMP	BYTE PTR SCRNBPC,16
	JNE	ANYOLDRET
	PUSH	BP			; MUST BE PRESERVED

	CLI
	MOV	DX, CRTCADDM+6
	IN	AL, DX
	MOV	DL, LOW (CRTCADDC+6)
	IN	AL, DX
	MOV	DL, LOW ATTCTLP
	MOV	AL, HORPPAN
	OUT	DX, AL
	MOV	AL, 0
	OUT	DX, AL
	TEST	EGADATA, EGAHASMONO	
	JNZ	BLUOK
	MOV	AL, 0FH
	OUT	DX, AL
	MOV	AL, 111111B
	OUT	DX, AL
BLUOK:	TEST	EGADATA, EGAHASMONO
	MOV	AX, 0F00H
	MOV	DI, 0B800H
	JZ	SCREENSEGOK
	MOV	AH, (1000B OR 0111B)
	MOV	DI, 0B000H
SCREENSEGOK:	MOV	ES, DI
	XOR DI,DI
	PUSH AX
	MOV AX,"0"
	MOV CX,80
	REP STOSW	
	POP AX
	ADD DI,2
CHALOOP1:	MOV CX,26
CHALOOP:	STOSW
	ADD AL,3
	LOOP CHALOOP
	SUB AL,26*3-1
	ADD DI,160-(26*2)
	CMP AL,3
	JNZ CHALOOP1
;
	IF LOTS
	PUSH AX
	MOV DI,160
	MOV CX,8
LPZ1:	PUSH CX
	MOV AH,1110B
	CALL BOX
	ADD DI,27*2
	MOV AH,1111B
	CALL BOX
	ADD DI,27*2
	MOV AH,1101B
	CALL BOX
	ADD DI,160*3-27*4
	POP CX
	LOOP LPZ1
	POP AX
	JMP SHORT LPZ2
;
BOX:	PUSH DI
	XOR AL,AL
BX0:	MOV CX,26
BX1:	STOSW
	ADD AL,3
	LOOP BX1
	SUB AL,26*3-1
	ADD DI,160-(26*2)
	CMP AL,3
	JNZ BX0
	POP DI
	RET
	ENDIF

;
;
LPZ2:
	IF SHIFTED
	PUSH DS
	PUSH ES
	POP DS
	MOV SI,160
	MOV DI,160+3*160
	MOV CX,7
BX2:	PUSH CX
	PUSH DI
	CALL SHIFT
	POP SI
	MOV DI,SI
	ADD DI,160*3
	POP CX
	LOOP BX2
	POP DS
	JMP SHORT LPZ3
;
SHIFT:	MOV CX,3
SH1:	PUSH DI
	PUSH SI
	MOV AX,154[SI]
	MOV 0[DI],AX
	MOV AX,156[SI]
	MOV 2[DI],AX
	MOV AX,158[SI]
	MOV 4[DI],AX
	ADD DI,6
	PUSH CX
	MOV CX,77
	REP MOVSW
	POP CX
	POP SI	
	POP DI
	ADD DI,160
	ADD SI,160
	LOOP SH1
	RET
LPZ3:
	ENDIF


	MOV AX,0B800H
	MOV ES,AX
	MOV DI,160*8+40
	MOV CX,9
SX1:	PUSH CX
	PUSH DI
	MOV CX,40
	MOV AX,70H*256+" "
	REP STOSW
	POP DI
	POP CX
	ADD DI,160
	LOOP SX1
;
;
;
	MOV DI,160*8+40
	MOV CX,39
	MOV AX,7000H+205
	REP STOSW
	MOV AL,187
	STOSW
	ADD DI,158
	MOV CX,7
SX2:	MOV BYTE PTR ES:[DI],186
	ADD DI,160
	LOOP SX2
	MOV BYTE PTR ES:[DI],188
	MOV CX,39
SX3:	SUB DI,2
	MOV BYTE PTR ES:[DI],205
	LOOP SX3
	MOV BYTE PTR ES:[DI],200
	MOV CX,8
SX4:	SUB DI,160
	MOV BYTE PTR ES:[DI],186
	LOOP SX4
	MOV BYTE PTR ES:[DI],201



	MOV DI,160*9+52
	MOV AX,219
	MOV CX,7
SX5:	STOSW
	STOSW
	STOSW
	STOSW
	INC AH
	LOOP SX5
	MOV DI,160*15+52
	MOV AX,219+6*256
	MOV CX,7
SX6:	STOSW
	STOSW
	STOSW
	STOSW
	DEC AH
	LOOP SX6




	MOV DI,160*11+64
	MOV SI,OFFSET ME1
	CALL PMES

	MOV DI,160*13+64
	MOV SI,OFFSET ME2
	CALL PMES










	MOV DX, SEQADDR
	MOV AX, RESETD+100H*(NOASYNKRES)
	OUT DX, AX
	MOV AX, CLKMODD+100H*(DOTS8)
	OUT DX, AX
	MOV AX, MAPMSKD+100H*(0100B)
	OUT DX, AX
	MOV AX, CHMAPD+100H*(000100B)
	OUT DX, AX
	MOV AX, MEMODD+100H*(NOTODEV+EXTMEM+ALPHA)
	OUT DX, AX
	MOV DL, LOW MISCOR
	MOV AL, 62H+CLK25M
	TEST EGADATA, EGAHASMONO
	PUSHF
	JNZ CONTENTOK
	INC AX
CONTENTOK:	OUT DX, AL
	MOV DL, LOW SEQADDR
	MOV AX, RESETD+100H*(NOSYNKRES+NOASYNKRES)
	OUT DX, AX
	MOV DL, LOW CRTCADDM
	POPF
	JNZ CRTCADDOK
	MOV DL, LOW CRTCADDC
CRTCADDOK:	MOV AX, CURSLHD+100H*(HIGH(80*25+0FFH))
	OUT DX, AX
	MOV DL, LOW GRA12AD
	MOV AX, MODREGD+100H*(WMPROC+0*ODEVADR)
	OUT DX, AX
	MOV AX, RMAPSED+100H*(2)
	OUT DX, AX
	MOV AX, MISREGD+100H*(MA000+0*CHNMAPS)
	OUT DX, AX
	MOV AX,0A400H
	MOV ES,AX
	MOV CX,32*75
	XOR DI,DI
	MOV AX,DI
	REP STOSW
	MOV DX,CRTCADDM+6
	IN AL,DX
	MOV DL,LOW (CRTCADDC+6)
	IN AL,DX
	MOV DL,LOW ATTCTLP
	MOV AL,20H
	OUT DX,AL
	STI
;





;
;
;
; Start of the main program
;
;
;
	ASSUME DS:DATA
	MOV AX,DATA
	MOV ES,AX
	MOV AX,CS
	MOV DS,AX
	MOV SI,OFFSET LOGODAT
	MOV DI,OFFSET LOGO
	XOR AH,AH
SET1:	LODSW
	MOV ES:1[DI],AL
	MOV ES:5[DI],AH		;Load in initial logo data
	LODSW
	MOV ES:9[DI],AL
	MOV ES:13[DI],AH
	ADD DI,16
	CMP DI,OFFSET LOGO+32*16
	JNZ SET1
;
	MOV AX,DATA
	MOV DS,AX
	MOV LASTL,OFFSET 16*15
;
;
; Print the logo to start with
;
	MOV CX,32
	MOV SI,OFFSET LOGO
MLOOP:	PUSH CX
	MOV AL,1[SI]
	MOV AH,5[SI]
	MOV WORD PTR X1,AX
	MOV AL,9[SI]
	MOV AH,13[SI]
	MOV WORD PTR X2,AX
	PUSH SI
	CALL LINE
	POP SI
	ADD SI,16
	POP CX
	LOOP MLOOP
	XOR CX,CX
	MOV BX,20
ML2:	LOOP $
	DEC BX
	JNZ ML2
;
;
AGAIN:	MOV AX,FUNCTION
	ADD AX,2
	AND AX,0FEH
	CMP AX,16
	JC SET2
	XOR AL,AL
SET2:	MOV FUNCTION,AX
;
	MOV BX,AX
	MOV AL,BYTE PTR TREPEAT[BX]
	SHR AL,1
	INC AX
	AND AL,255-1
	MOV MCOUNT,AL
;
;
;
; Now generate new end positions
;
;
BACK:	CMP FUNCTION,2
	JNZ LP0A
	MOV DI,LASTL
	ADD DI,16
	CMP DI,OFFSET LOGO+16*32
	JNZ SHORT LP0
	MOV DI,OFFSET LOGO+16*2
LP0:	MOV LASTL,DI
;
LP0A:	MOV SI,OFFSET LOGO
	MOV CX,32
	CMP FUNCTION,14
	JNZ LP1A
	MOV BP,OFFSET COMPDAT
	TEST MCOUNT,1
	JZ LP1
LP1A:	MOV BP,OFFSET LOGODAT
LP1:	MOV BX,FUNCTION
	CALL CS:SETUP[BX]
	XOR AL,AL
	MOV BYTE PTR 0[SI],AL
	MOV BYTE PTR 4[SI],AL
	MOV BYTE PTR 8[SI],AL
	MOV BYTE PTR 12[SI],AL
	ADD SI,16
	ADD DI,16
	CMP DI,OFFSET LOGO+16*32
	JNZ SHORT LP2
	MOV DI,OFFSET LOGO
LP2:	LOOP LP1
;
;
;
;
;
; Now enter the line moving loop.
;
;
;
;
	IF WIZZ
	MOV COUNT,64
	ELSE
	MOV COUNT,128
	ENDIF
LP4:	MOV CX,32
	MOV SI,OFFSET LOGO
LP3:	PUSH CX
	MOV AL,1[SI]
	MOV AH,5[SI]		;X1,Y1
	PUSH AX
	MOV AL,9[SI]
	MOV AH,13[SI]		;X2,Y2
	PUSH AX
;
	IF WIZZ
	MOV AX,2[SI]
	ADD [SI],AX
	MOV AX,6[SI]
	ADD 4[SI],AX
	MOV AX,10[SI]		;Move coords
	ADD 8[SI],AX
	MOV AX,14[SI]
	ADD 12[SI],AX
	ENDIF
	MOV AX,2[SI]
	ADD [SI],AX
	MOV AX,6[SI]
	ADD 4[SI],AX
	MOV AX,10[SI]		;Move coords
	ADD 8[SI],AX
	MOV AX,14[SI]
	ADD 12[SI],AX
;
	MOV AL,1[SI]
	MOV AH,5[SI]
	MOV WORD PTR X1,AX
	MOV AL,9[SI]
	MOV AH,13[SI]
	MOV WORD PTR X2,AX
	PUSH SI
	CALL LINE		;Draw new line
	POP SI
;
	POP WORD PTR X2
	POP WORD PTR X1
	PUSH SI
	CALL LINE		;Erase old line
	POP SI
;
	POP CX
	ADD SI,16
	LOOP LP3
;
LPSA:	IF WIZZ
	ELSE
	MOV AX,64
	SUB AX,COUNT
	TEST AX,32768
	JZ NN1
	NEG AX
NN1:	TEST AX,32
	JZ ANN2
	MOV BX,AX
	SHR BX,1
	ADD AX,BX
ANN2:	ADD AX,8
	MOV CX,AX
	ADD CX,CX
	ADD CX,CX
NN2:	MOV AX,15
NN3:	DEC AX
	JNZ NN3
	LOOP NN2
	ENDIF
;
	DEC COUNT
	JZ ALP4
	JMP LP4
ALP4:
;	IF WIZZ
	CMP FUNCTION,14
	JNZ ALP5
	MOV BX,10
	XOR CX,CX	
AASX:	LOOP $
	DEC BX
	JNZ AASX
;	ELSE
	MOV BX,15
	CMP FUNCTION,14
	JZ ALP5AA
	CMP FUNCTION,10
	JZ ALP5A
	CMP FUNCTION,6
	JZ ALP5A
	CMP FUNCTION,2
	JNZ ALP5
ALP5A:	MOV BX,11
ALP5AA:	XOR CX,CX
ALP6:	LOOP $
	DEC BX
	JNZ ALP6
;	ENDIF
ALP5:	DEC MCOUNT
	JZ EXIT
	JMP BACK
;


EXIT:	MOV AH,1
	INT 16H
	JNZ EXIT1
	JMP AGAIN
EXIT1:	JMP FINISHED








;
;
; Different setup routines
;
;
ROTY:	MOV AL,104		;Rotate about Y axis
	SUB AL,1[SI]
	CBW
	ADD AX,AX
	ADD AX,AX
	MOV 2[SI],AX
	MOV WORD PTR 6[SI],0
	MOV AL,104
	SUB AL,9[SI]
	CBW
	ADD AX,AX
	ADD AX,AX
	MOV 10[SI],AX
	MOV WORD PTR 14[SI],0
	RET
;
ROTX:	MOV WORD PTR 2[SI],0	;Rotate about X axis
	MOV AL,36
	SUB AL,5[SI]
	CBW
	ADD AX,AX
	ADD AX,AX
	MOV 6[SI],AX
	MOV WORD PTR 10[SI],0
	MOV AL,36
	SUB AL,13[SI]
	CBW
	ADD AX,AX
	ADD AX,AX
	MOV 14[SI],AX
	RET
;
SCRAMBLE:	MOV DL,1[DI]
	MOV DH,5[DI]
	MOV BL,9[DI]
	MOV BH,13[DI]
	JMP SHORT MOVETO
;
SQU1:	TEST MCOUNT,1		;Shrink and expand logo
	JZ SQA
	MOV DX,CS:[BP]
	MOV BX,CS:2[BP]
	ADD BP,4
	JMP SHORT MOVETO
SQA:	MOV DX,2468H
	MOV BX,2468H
;
MOVETO:	XOR AH,AH		;Move line to
	MOV AL,DL		;DL,DH BL,BH (x1,y2 x2,y2)
	SUB AL,1[SI]
	JNC SC5
	DEC AH
SC5:	ADD AX,AX
	MOV 2[SI],AX
	XOR AH,AH
	MOV AL,DH
	SUB AL,5[SI]
	JNC SC6
	DEC AH
SC6:	ADD AX,AX
	MOV 6[SI],AX
	XOR AH,AH
	MOV AL,BL
	SUB AL,9[SI]
	JNC SC7
	DEC AH
SC7:	ADD AX,AX
	MOV 10[SI],AX
	XOR AH,AH
	MOV AL,BH
	SUB AL,13[SI]
	JNC SC8
	DEC AH
SC8:	ADD AX,AX
	MOV 14[SI],AX
	RET
;
FLAT1:	TEST MCOUNT,1		;Shrink and expand logo
	JZ SQB
XSQB:	MOV DX,CS:[BP]
	MOV BX,CS:2[BP]
	ADD BP,4
	JMP MOVETO
SQB:	MOV DL,CS:[BP]
	MOV BL,CS:2[BP]
	ADD BP,4
	MOV DH,20
	TEST MCOUNT,2
	JZ SQC
	MOV DH,52
SQC:	MOV BH,DH
	JMP MOVETO
;
FLAT2:	TEST MCOUNT,1		;Shrink and expand logo
	JNZ XSQB
	MOV DH,CS:1[BP]
	MOV BH,CS:3[BP]
	ADD BP,4
	MOV DL,8
	TEST MCOUNT,2
	JZ XSQC
	MOV DL,200
XSQC:	MOV BL,DL
	JMP MOVETO
;
EXPLO:	TEST MCOUNT,2
	JNZ EXPLO1
	TEST MCOUNT,1
	JNZ XSQB
	MOV DX,200+52*256
	TEST CL,1
	JZ MOVETOA
	MOV DX,8+20*256
	JMP SHORT MOVETOA
;
EXPLO1:	TEST MCOUNT,1
	JNZ XSQB
	MOV DX,8+52*256
	TEST CL,1
	JZ MOVETOA
	MOV DX,200+20*256
MOVETOA:	MOV BX,DX
	JMP MOVETO
;












	ASSUME DS:DS40H
FINISHED:	MOV AX,DS40H
	MOV DS,AX
	MOV DX,GRA12AD
	MOV AX,RMAPSED+100H*(0)
	OUT DX,AX
;
	MOV AX,1104H
	XOR BL,BL
	INT 10H
;*
	STI
	OR EGADATA,10H
	POP BP
	RET






ME1	DB "Spinning logo demo",0
ME2	DB "BY Andrew Glaister",0

PMES:	LODS BYTE PTR CS:[SI]
	AND AL,AL
	JZ PMES1
	STOSB
	INC DI
	JMP PMES
PMES1:	RET




;
;
;
;
;
;
PLOGO_DONE:	PUSH	AX
	PUSH	CX
	PUSH	DX
	PUSH	DI
	PUSH	ES
	PUSH	DS
	MOV AX,DS40H
	MOV DS,AX

	AND EGADATA, NOT (10H)
;
	MOV AL,BYTE PTR DEVFLG
	OR AL,11001111B
	INC AL
	MOV AX,0B000H
	JZ GOTSEG
	MOV AH,0B8H
GOTSEG:	MOV ES,AX
	XOR DI,DI
PLOFIXFOR:	TEST BYTE PTR ES:3[DI],11111111B
	JZ PLOFIXFIRST
	TEST BYTE PTR ES:3[DI],1000B
	JZ PLOFIXLAST
PLOFIXFIRST:	MOV CX,80
	MOV AX,0720H
	REP STOSW
	JMP PLOFIXFOR
;
;
PLOFIXLAST:	PUSH	CURCOOR			; SAVE CURSOR POSITION
	XOR	AX,AX
	MOV	AL,CRTMODE
	OR	AL,80H			; SCREEN PRESERVE FLAG
	INT	10H			; SET MODE
	AND	EGADATA, NOT (80H)		; CLEAR SCREEN PRESERVE FLAG
	POP	CURCOOR			; RESTORE CURSOR POSITION
	POP	DS
	POP	ES
	POP	DI
	POP	DX
	POP	CX
	POP	AX
	RET





;
;
; x1,y1 to x2,y2
; Coords must be 8,20 to 200,52
;
;
	ASSUME DS:DATA
LINE:	PUSH ES
	MOV AX,FONT
	MOV ES,AX
;
	SUB WORD PTR X1,8+20*256
	SUB WORD PTR X2,8+20*256
;
	MOV SI,1
	MOV DI,16
	MOV CL,X2
	SUB CL,X1
	JZ VERT
	JNS L01
	NEG CL
	MOV BL,X2
	XCHG BL,X1
	MOV X2,BL
	MOV BL,Y2
	XCHG BL,Y1
	MOV Y2,BL
;
L01:	MOV BL,Y2
	SUB BL,Y1
	JZ HORI
	JNS L03
	NEG BL
	NEG SI
	NEG DI
;
L03:	MOV LEAF,DI
	MOV LROUTINE,OFFSET LOLINE
	CMP BL,CL
	JLE L04
	MOV LROUTINE,OFFSET HILINE
	XCHG BL,CL
;
L04:	XOR BH,BH
	MOV CH,BH
	SHL BX,1
	MOV INC1,BX
	SUB BX,CX
	MOV DI,BX
	SUB BX,CX
	MOV INC2,BX
;
	PUSH CX
	MOV AL,Y1
	MOV BL,X1
	CALL GETADD
	MOV DL,AL
	POP CX
	INC CX
	JMP LROUTINE
;
;
	deven
VERT:	MOV AL,Y1
	MOV BL,Y2
	MOV CL,BL
	SUB CL,AL
	JGE L31
	NEG CL
	MOV AL,BL
L31:	XOR CH,CH
	INC CX
	MOV BL,X1
	PUSH CX
	CALL GETADD
	POP CX
L32:	XOR ES:[BX],AL
	ADD BX,SI
	TEST BL,16
	JNZ L33
	LOOP L32
	POP ES
	RET
	deven
L33:	ADD BX,DI
	LOOP L32
	POP ES
	RET
;
;
	deven
HORI:	MOV AL,Y1
	MOV BL,X1
	CALL GETADD
	MOV DI,BX
	MOV DX,0FFFFH
	SHR DH,CL
	MOV CL,X2
	AND CL,7
	XOR CL,7
	SHL DL,CL
	MOV CL,X2
	MOV AL,X1
	SHR CL,3
	SHR AL,3
	SUB CL,AL
	XOR CH,CH
	OR DH,DH
	JS L43
	OR CX,CX
	JNZ L42
	AND DL,DH
	JMP SHORT L44
	deven
L42:	XOR ES:[DI],DH
	ADD DI,96
	DEC CX
L43:	JCXZ L44
L45:	NOT BYTE PTR ES:[DI]
	ADD DI,96
	LOOP L45
L44:	XOR ES:[DI],DL
	POP ES
	RET
;
;
	deven
LOLINE:	MOV AH,ES:[BX]
L11:	XOR AH,DL
	ROR DL,1
	JC L14
	OR DI,DI
	JNS L12
	ADD DI,INC1
	LOOP L11
	MOV ES:[BX],AH
	POP ES
	RET
	deven
L12:	MOV ES:[BX],AH
	ADD DI,INC2
	ADD BX,SI
	TEST BL,16
	JZ L13
	ADD BX,LEAF
L13:	LOOP LOLINE
	POP ES
	RET
	deven
L14:	MOV ES:[BX],AH
	ADD BX,96
	OR DI,DI
	JNS L15
	ADD DI,INC1
	LOOP LOLINE
	POP ES
	RET
	deven
L15:	ADD DI,INC2
	ADD BX,SI
	TEST BL,16
	JZ L16
	ADD BX,LEAF
L16:	LOOP LOLINE
	POP ES
	RET
;
;
	deven
HILINE:	XOR ES:[BX],DL
	ADD BX,SI
	TEST BL,16
	JNZ L22
	OR DI,DI
	JNS L23
	ADD DI,INC1
L24:	LOOP HILINE
	POP ES
	RET
	deven
L22:	ADD BX,LEAF
	OR DI,DI
	JNS L23
	ADD DI,INC1
	LOOP HILINE
	POP ES
	RET
	deven
L23:	ADD DI,INC2
	ROR DL,1
	JNC L24
	ADD BX,96
	LOOP HILINE
	POP ES
	RET
	deven
;
; AX=Y, BX=X   return AL=Bit to set, ES:BX=Byte to set, CL=0-7 shift of pixel
;
GETADD:	MOV CL,AL
	AND AL,0FH
	XOR CL,AL
	SAL CL,1
	OR AL,CL
	MOV CL,BL
	SHR BL,3
	AND CL,7
	MOV DX,AX
	MOV AL,96
	MUL BL
	XOR DH,DH
	ADD AX,DX
	MOV BX,AX
	MOV AL,128
	SHR AL,CL
	RET






CODE	ENDS
	END START
